Activer / Désactiver une option du système sous SolidWorks via les API

Bonjour à tous,

 

 

Suite à une question du forum voici un exemple d'API SolidWorks permettant de cocher / décocher une option du système.

 

Vous trouverez ici le sujet initial

 

Dans notre cas, il s'agit de l'option "Modifier les cotes pendant l'opération glisser / déposer", situé dans le menu "Esquisse" des options du système.

 

 

Pour ce type de demande, il y a deux commandes à notre disposition:

  • GetUserPreferenceToggle
  • SetUserPreferenceToggle

 

La commande "GetUserPreferenceToggle" va nous permettre de contrôler, si l'option est activé ou non.

La seconde commande "SetUserPreferenceToggle" , nous permettra alors de cocher ou décocher en fonction du résultat du "GetUserPreferenceToggle".

 

Le but étant d'avoir quelque chose similaire à un interrupteur (ON / OFF) et non deux boutons.

 

Pour ceux qui ne sont pas familier avec les API, vous pouvez vous reporter au tableau des options ci-dessous.

 

ici = > Options du système et propriétés du document

 

Voici le code que j'utilise:

Sub main()

Dim swApp As Object
Dim OptAct As Boolean

Set swApp = Application.SldWorks

 

OptAct = swApp.GetUserPreferenceToggle(swUserPreferenceToggle_e.swSketchOverrideDimensionsOnDrag)

 

If OptAct = True Then
OptAct = swApp.SetUserPreferenceToggle(swUserPreferenceToggle_e.swSketchOverrideDimensionsOnDrag, False)

ElseIf OptAct = False Then
OptAct = swApp.SetUserPreferenceToggle(swUserPreferenceToggle_e.swSketchOverrideDimensionsOnDrag, True)

End If

End Sub

 

Les zones bleues sont les déclarations

La zone orange permet de vérifie l'activation ou la non activation de la fonction

La zone violette permet via la condition "If" de choisir de l'activer ou non en fonction du résultat de la zone orange.

 

Je vous joins le fichier en version 2011. (téléchargeable ici), pour les autres versions, il suffit de refaire le fichier en copiant /collant le code ci-dessus et en y ajoutant les références ci besoin.

 

Bonne journée.

Ajoutez un commentaire :

BIENVENUE DANS LE GUIDE 3D SOLIDWORS